<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.9.0"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>API: OpenSim::ThreadsafeJar&lt; T &gt; Class Template Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/x-mathjax-config">
  MathJax.Hub.Config({
    extensions: ["tex2jax.js"],
    jax: ["input/TeX","output/HTML-CSS"],
});
</script>
<script type="text/javascript" async="async" src="MathJax-2.7.0/MathJax.js"></script>
<link href="doxygen_developer.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="OpenSimLogoWhiteHorizontal_small.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">API
   &#160;<span id="projectnumber">4.4.1-2022-09-05-d4bb9bc34</span>
   </div>
   <div id="projectbrief">For C++ developers</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.0 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('classOpenSim_1_1ThreadsafeJar.html',''); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="summary">
<a href="classOpenSim_1_1ThreadsafeJar-members.html">List of all members</a> &#124;
<a href="#pub-methods">Public Member Functions</a>  </div>
  <div class="headertitle">
<div class="title">OpenSim::ThreadsafeJar&lt; T &gt; Class Template Reference<div class="ingroups"><a class="el" href="group__commonutil.html">Common Utilities</a></div></div>  </div>
</div><!--header-->
<div class="contents">

<p>This class lets you store objects of a single type for reuse by multiple threads, ensuring threadsafe access to each of those objects.  
 <a href="classOpenSim_1_1ThreadsafeJar.html#details">More...</a></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:ab4ae9922ba2cc9f2448f6242f1e7f023"><td class="memItemLeft" align="right" valign="top">std::unique_ptr&lt; T &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1ThreadsafeJar.html#ab4ae9922ba2cc9f2448f6242f1e7f023">take</a> ()</td></tr>
<tr class="memdesc:ab4ae9922ba2cc9f2448f6242f1e7f023"><td class="mdescLeft">&#160;</td><td class="mdescRight">Request an object for your exclusive use on your thread.  <a href="classOpenSim_1_1ThreadsafeJar.html#ab4ae9922ba2cc9f2448f6242f1e7f023">More...</a><br /></td></tr>
<tr class="separator:ab4ae9922ba2cc9f2448f6242f1e7f023"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac59b1ecf3dba8aa2d31a3d2be542c4cc"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1ThreadsafeJar.html#ac59b1ecf3dba8aa2d31a3d2be542c4cc">leave</a> (std::unique_ptr&lt; T &gt; entry)</td></tr>
<tr class="memdesc:ac59b1ecf3dba8aa2d31a3d2be542c4cc"><td class="mdescLeft">&#160;</td><td class="mdescRight">Add or return an object so that another thread can use it.  <a href="classOpenSim_1_1ThreadsafeJar.html#ac59b1ecf3dba8aa2d31a3d2be542c4cc">More...</a><br /></td></tr>
<tr class="separator:ac59b1ecf3dba8aa2d31a3d2be542c4cc"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a06242bf9d123d889262bd349f23234fa"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1ThreadsafeJar.html#a06242bf9d123d889262bd349f23234fa">size</a> () const</td></tr>
<tr class="memdesc:a06242bf9d123d889262bd349f23234fa"><td class="mdescLeft">&#160;</td><td class="mdescRight">Obtain the number of entries that can be taken.  <a href="classOpenSim_1_1ThreadsafeJar.html#a06242bf9d123d889262bd349f23234fa">More...</a><br /></td></tr>
<tr class="separator:a06242bf9d123d889262bd349f23234fa"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description </h2>
<div class="textblock"><h3>template&lt;typename T&gt;<br />
class OpenSim::ThreadsafeJar&lt; T &gt;</h3>

<p>This class lets you store objects of a single type for reuse by multiple threads, ensuring threadsafe access to each of those objects. </p>
</div><h2 class="groupheader">Member Function Documentation</h2>
<a id="ac59b1ecf3dba8aa2d31a3d2be542c4cc"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ac59b1ecf3dba8aa2d31a3d2be542c4cc">&#9670;&nbsp;</a></span>leave()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOpenSim_1_1ThreadsafeJar.html">OpenSim::ThreadsafeJar</a>&lt; T &gt;::leave </td>
          <td>(</td>
          <td class="paramtype">std::unique_ptr&lt; T &gt;&#160;</td>
          <td class="paramname"><em>entry</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Add or return an object so that another thread can use it. </p>
<p>You will need to std::move() the entry, ensuring that you will no longer have access to the entry in your code (the pointer will now be null). </p>

</div>
</div>
<a id="a06242bf9d123d889262bd349f23234fa"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a06242bf9d123d889262bd349f23234fa">&#9670;&nbsp;</a></span>size()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">int <a class="el" href="classOpenSim_1_1ThreadsafeJar.html">OpenSim::ThreadsafeJar</a>&lt; T &gt;::size </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Obtain the number of entries that can be taken. </p>

</div>
</div>
<a id="ab4ae9922ba2cc9f2448f6242f1e7f023"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ab4ae9922ba2cc9f2448f6242f1e7f023">&#9670;&nbsp;</a></span>take()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">std::unique_ptr&lt;T&gt; <a class="el" href="classOpenSim_1_1ThreadsafeJar.html">OpenSim::ThreadsafeJar</a>&lt; T &gt;::take </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Request an object for your exclusive use on your thread. </p>
<p>This function blocks the thread until an object is available. Make sure to return (<a class="el" href="classOpenSim_1_1ThreadsafeJar.html#ac59b1ecf3dba8aa2d31a3d2be542c4cc" title="Add or return an object so that another thread can use it.">leave()</a>) the object when you're done! </p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li>OpenSim/Common/CommonUtilities.h</li>
</ul>
</div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="namespaceOpenSim.html">OpenSim</a></li><li class="navelem"><a class="el" href="classOpenSim_1_1ThreadsafeJar.html">ThreadsafeJar</a></li>
    <li class="footer">Generated on Mon Sep 5 2022 20:49:32 for API by <a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.0 </li>
  </ul>
</div>
</body>
</html>
